/*
 * Copyright © 2024 Nicole O'Connor
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * 	http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
class PowerWeaponLevel2HGA : PowerWeaponLevel2 {
	override void EndEffect() {
		let ply = ChexPlayerHGA(Owner);
		ply.PowerModulatorCooling = false; // placeholder for secondary cooldown effect logic
		Super.EndEffect();
	}
}

class InvPowerModulator : PowerupGiver {
	Default {
		//$Category "Powerups"
		//$Title "Power Modulator"
		+COUNTITEM
		Tag "$TAG_POWERMODULATOR";
		Powerup.Type "PowerWeaponLevel2HGA";
		Powerup.Duration -15;
		Inventory.Icon "NULLA0";
		Inventory.AltHUDIcon "NULLA0";
		Inventory.PickupMessage "$TXT_POWERMODULATOR";
	}
	
	States {
	Spawn:
		NULL A -1;
		Stop;
	}
	
	override bool Use(bool pickup) {
		let ply = ChexPlayerHGA(Owner);
		
		if (ply.PowerModulatorCooling) { return false; }
		else {
			ply.PowerModulatorCooling = true; // start the cooldown
			return Super.Use(pickup); // hand off to zdoom for std "weaponlevel2" effect
		}
	}
}